<?php
function squirrelmail_plugin_init_domain_keys() {
    global $squirrelmail_plugin_hooks;
    $squirrelmail_plugin_hooks['compose_send']['domain_keys'] = 'plugin_domain_keys_sign';
}

function plugin_domain_keys_sign(&$args) {
    global $domain;
    include_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . 'domain_keys.php');

    // these should be in a config somewhere...
    $selector = DOMAINKEYS_DEFAULT_SELECTOR;
    $key_file = null;

    $ddk = new Deliver_DomainKeys();
    $ddk->initStream($domain);
    $ddk->mail($args[1]);
    $ddk->finalizeStream();
    list($key, $value) = explode(':', $ddk->sign($selector, $key_file), 2);
    $args[1]->rfc822_header->pre_headers[$key] = $value;
}

function plugin_domain_keys_check($message) {
    include_once(dirname(__FILE__) . DIRECTORY_SEPARATOR . 'domain_keys.php');
    $ddk = new Deliver_DomainKeys();
    $ddk->initStream($domain);
    $ddk->mail($composeMessage);
    $ddk->finalizeStream();
    return ($ddk->check() == DOMAINKEY_STATUS_GOOD) ? true : false;
}

function domain_keys_version() {
    return '1.0';
}

?>